diff -u -r -N rdnzl-0.10.9\container.lisp rdnzl-new-cast\container.lisp
--- rdnzl-0.10.9\container.lisp	Tue Jan 02 00:53:04 2007
+++ rdnzl-new-cast\container.lisp	Tue May 08 16:59:38 2007
@@ -446,13 +446,22 @@
                                 container)
   container)
 
+(defun cast-to-type-object (container type)
+  "Like CAST, but assumes TYPE is a TYPE object Unlike CAST*, will work with types loaded in a LoadFrom context."
+  (ffi-call-with-foreign-string %set-dot-net-container-type-from-container
+                  nil
+                  type
+                  container)
+   container)
+  
 (defun cast (container type)
   "Changes the type of the DotNetContainer object represented by
 CONTAINER to TYPE \(a string or a CONTAINER).  Returns CONTAINER."
-  (cast* container (cond ((stringp type)
-                          (resolve-type-name type))
-                         (t
-                          (property type "AssemblyQualifiedName")))))
+  (cond 
+   ((stringp type)
+     (cast* container (resolve-type-name type)))
+   (t
+     (cast-to-type-object container type))))
 
 (defun make-null-object* (type-name)
   "Creates a NULL DotNetContainer with the type named by the string
diff -u -r -N rdnzl-0.10.9\ffi.lisp rdnzl-new-cast\ffi.lisp
--- rdnzl-0.10.9\ffi.lisp	Tue Jan 02 00:53:04 2007
+++ rdnzl-new-cast\ffi.lisp	Tue May 08 17:00:30 2007
@@ -232,6 +232,11 @@
      (ptr ffi-void-pointer))
   ffi-void-pointer)
 
+(ffi-define-function "setDotNetContainerTypeFromContainer"
+    ((type ffi-void-pointer)
+     (ptr ffi-void-pointer))
+  ffi-void-pointer)
+
 (ffi-define-function "getDotNetContainerObjectStringLength"
     ((ptr ffi-void-pointer))
   ffi-integer)
